diff -crN nakedmudv1.5/src/.gdb_history nakedmudv2.0/src/.gdb_history
*** nakedmudv1.5/src/.gdb_history	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/.gdb_history	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,51 ****
  run
! bt
  quit
  run
  bt
- qiut
  quit
  quit
  run
  bt
  quit
  run
  quit
! run
  bt
  quit
  run
  bt
- print buflen
- up
  up
  up
! up
! up
! print buflen
! print buf
! print i
  quit
  run
  quit
  run
  bt
- bt
  quit
  run
! bt
  quit
  run
! bt
! bt
! print dsock->player
! print dsock->page
! print dsock->page_string
! q
! run
! print dsock->page_string
! print dsock->player
! print dsock
  bt
  quit
  run
--- 1,44 ----
  run
! quit
! run
  quit
  run
  bt
  quit
+ run
  quit
  run
  bt
  quit
  run
+ bt
  quit
! run 4000
  bt
  quit
  run
  bt
  up
  up
! print data
! print data->curr_path
! print listSize(data->curr_path)
  quit
  run
  quit
  run
  bt
  quit
  run
! print i
! print j
! print map->rooms[i]
! print map->rooms[j]
! print map->rooms
  quit
  run
! quit
! run 4000
  bt
  quit
  run
***************
*** 55,164 ****
  quit
  run
  bt
! print dsock
! print dsock->control
! print rFd
! print dsock->outbuf
! print dsock->inbuf
! print dsock->state
! print dsock->indent
  quit
  run
- clear
  bt
  quit
  run
  bt
  quit
  run
  quit
  run
  quit
  run
  quit
  run
  bt
  quit
  run
  quit
  run
  bt
  quit
  run
  quit
! run 3000
! quit
! run 4000
  bt
  bt
- up
- print i
  down
- print i
- print num
  up
  up
  up
! bt
! print i
! print param
! print one_arg
! print arg
! print one_arg
! quit
! run 3000
  quit
  run 4000
  bt
  quit
  run 4000
- quit
- run 3000
  bt
  quit
  run 4000
! bt
  quit
  run 4000
  quit
! run
  quit
  run
  quit
  run
  quit
  bt
! info local
! bt
! ls -l
  bt
  down
  up
  up
! bt
  quit
  bt
  quit
  run
  bt
- up
- print event
- print event->owner
- print event->data
- print event->arg
- print event->delay
- print events
- print events->size
- print events->head->elem
- print events->head->removed
- print events->head->next->removed
- print events->head->next->next->removed
- print events->head->next->next->next->removed
- print events->head->next->next->next->next->removed
- print events->head->next->next->next->next->next->removed
- print events->head->next->next->next->next->next->next->removed
- print events->head->next->next->next->next->next->next->next->removed
- print events->head->next->next->next->next->next->next->next->next->removed
  quit
  run
  quit
--- 48,150 ----
  quit
  run
  bt
! quit
! run 4000
! print data
  quit
  run
  bt
  quit
  run
+ print val
+ print val
  bt
+ print num_bits
+ print bits
+ clear
  quit
  run
+ print val
  quit
  run
  quit
  run
+ bt
  quit
  run
  bt
  quit
  run
+ bt
+ quit
+ run 4000
  quit
  run
  bt
  quit
  run
+ bt
  quit
! run
  bt
+ print L
+ print listSize(L)
+ down
+ print
+ info local
+ info
  bt
  down
  up
+ bt
  up
  up
! print listSize(scripts)
  quit
  run 4000
  bt
  quit
  run 4000
  bt
+ print data
+ print data->item_table
+ print type
+ print funcs
  quit
  run 4000
! shutdo
  quit
  run 4000
  quit
! quit
! run 4000
! bt
  quit
  run
  quit
  run
  quit
+ run
  bt
! quit
! run
  bt
  down
  up
  up
! up
! print key
! print data
! print (char *)data
! print data->item_table
! print funcs
! print key
  quit
+ run 4000
  bt
  quit
  run
  bt
  quit
  run
  quit
***************
*** 166,219 ****
  bt
  quit
  run
! print event
! print event->owner
! print sizeof(*event->owner)
! bt
! print ev_i->L->size
! print ev_i->curr
! print ev_i->L->head
! print ev_i->L->head->next
! print ev_i->L->head->next->removed
! print ev_i->L->head->removed
! bt
! print event
! print event->delay
! print time
! info local
! info global
! help info
! info all-registers
! man info
! help info
! info thread
! info stack
! info scope
! info
  quit
  run
! print 0x30bfa0
! print 0x30bfa0
  quit
  run
! print event
  quit
  run
  quit
  run
- print node
- print node->next
  quit
  run
  quit
  run
  quit
  run
  quit
  run
  bt
  quit
! run
  quit
  run
  bt
--- 152,205 ----
  bt
  quit
  run
! bt
! down
! up
! up
! up
! up
! print key
! print val
! print type_table
! print hashSize(type_table)
  quit
  run
! bt
! quit
! run 4000
! bt
! up
! up
! up
! up
! print key
! print val
! print hash_i
! print val
! info local
  quit
  run
! bt
  quit
  run
  quit
  run
  quit
  run
+ bt
  quit
  run
+ bt
  quit
  run
  quit
  run
  bt
+ print type
  quit
! run 4000
! bt
! run 4000
  quit
  run
  bt
***************
*** 221,236 ****
  run
  bt
  quit
! run 4000
! bt
  quit
  run
  bt
! up
! up
! print data
! print data->curr_path
! print listSize(data->curr_path)
  quit
  run
  quit
--- 207,220 ----
  run
  bt
  quit
! run
  quit
  run
+ run
+ q
+ run
  bt
! clear
  quit
  run
  quit
***************
*** 238,256 ****
  bt
  quit
  run
! print i
! print j
! print map->rooms[i]
! print map->rooms[j]
! print map->rooms
  quit
  run
  quit
! run 4000
  bt
  quit
  run
  quit
  run
  bt
  quit
--- 222,256 ----
  bt
  quit
  run
! bt
  quit
  run
+ bt
  quit
! run
  bt
  quit
  run
+ bt
+ up
+ print from->prfs
+ print to->prfs
+ print from->name
+ print to->name
+ print from->prfs
  quit
  run
  bt
  quit
+ run
+ make
+ run
+ make
+ make
+ make
+ make
+ run
+ make
+ clear
+ run
+ quit
diff -crN nakedmudv1.5/src/handler.c nakedmudv2.0/src/handler.c
*** nakedmudv1.5/src/handler.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/handler.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,34 ****
  #include "object.h"
  #include "utils.h"
  #include "body.h"
- #include "items.h"
  #include "inform.h"
  
! // optional modules
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  //*****************************************************************************
- //
  // obj/char from/to functions
- //
  //*****************************************************************************
  void obj_from_char(OBJ_DATA *obj) {
    if(objGetCarrier(obj)) {
--- 16,37 ----
  #include "object.h"
  #include "utils.h"
  #include "body.h"
  #include "inform.h"
  
! 
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! #include "items/items.h"
! #include "items/container.h"
! #include "items/worn.h"
! 
  
  
  //*****************************************************************************
  // obj/char from/to functions
  //*****************************************************************************
  void obj_from_char(OBJ_DATA *obj) {
    if(objGetCarrier(obj)) {
***************
*** 178,184 ****
  //
  //*****************************************************************************
  void do_get(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
!   if(objIsBitSet(obj, BITFIELD_OBJ, OBJ_NOTAKE))
      send_to_char(ch, "You cannot take %s.\r\n", objGetName(obj));
    else if(container) {
      send_to_char(ch, "You get %s from %s.\r\n", 
--- 181,187 ----
  //
  //*****************************************************************************
  void do_get(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
!   if(bitIsOneSet(objGetBits(obj), "notake"))
      send_to_char(ch, "You cannot take %s.\r\n", objGetName(obj));
    else if(container) {
      send_to_char(ch, "You get %s from %s.\r\n", 
***************
*** 199,219 ****
  
  void do_put(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
    if(containerIsClosed(container))
!     send_to_char(ch, "%s is closed. Open it first.\r\n", objGetName(container));
    else if(obj == container)
      send_to_char(ch, "You cannot put %s into itself.\r\n", objGetName(obj));
    // make sure we have enough room
    else if(objGetWeight(obj) > 
! 	  (objGetCapacity(container) - 
  	   objGetWeight(container) + objGetWeightRaw(container)))
      send_to_char(ch, "There is not enough room in %s for %s.\r\n", 
! 		 objGetName(container), objGetName(obj));
    // do the move
    else {
      obj_from_char(obj);
      obj_to_obj(obj, container);
      send_to_char(ch, "You put %s into %s.\r\n", 
! 		 objGetName(obj), objGetName(container));
      message(ch, NULL, obj, container, TRUE, TO_ROOM | TO_NOTCHAR,
  	    "$n puts $o into $O.");
    }
--- 202,223 ----
  
  void do_put(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
    if(containerIsClosed(container))
!     send_to_char(ch, "%s is closed. Open it first.\r\n", 
! 		 see_obj_as(ch, container));
    else if(obj == container)
      send_to_char(ch, "You cannot put %s into itself.\r\n", objGetName(obj));
    // make sure we have enough room
    else if(objGetWeight(obj) > 
! 	  (containerGetCapacity(container) - 
  	   objGetWeight(container) + objGetWeightRaw(container)))
      send_to_char(ch, "There is not enough room in %s for %s.\r\n", 
! 		 see_obj_as(ch, container), see_obj_as(ch, obj));
    // do the move
    else {
      obj_from_char(obj);
      obj_to_obj(obj, container);
      send_to_char(ch, "You put %s into %s.\r\n", 
! 		 see_obj_as(ch, obj), see_obj_as(ch, container));
      message(ch, NULL, obj, container, TRUE, TO_ROOM | TO_NOTCHAR,
  	    "$n puts $o into $O.");
    }
***************
*** 230,236 ****
    obj_from_char(obj);
    obj_to_char(obj, recv);
  
- #ifdef MODULE_SCRIPTS  
    // object give
    try_scripts(SCRIPT_TYPE_GIVE,
  	      obj, SCRIPTOR_OBJ,
--- 234,239 ----
***************
*** 240,246 ****
    try_scripts(SCRIPT_TYPE_GIVE,
  	      recv, SCRIPTOR_CHAR,
  	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
- #endif
  }
  
  
--- 243,248 ----
***************
*** 249,255 ****
    obj_from_char(obj);
    obj_to_room(obj, charGetRoom(ch));
  
- #ifdef MODULE_SCRIPTS  
    // check for triggers
    try_scripts(SCRIPT_TYPE_DROP,
  	      charGetRoom(ch), SCRIPTOR_ROOM,
--- 251,256 ----
***************
*** 257,268 ****
    try_scripts(SCRIPT_TYPE_DROP,
  	      obj, SCRIPTOR_OBJ,
  	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
- #endif
  }
  
  
  void do_wear(CHAR_DATA *ch, OBJ_DATA *obj, const char *where) {
!   if(objGetType(obj) != ITEM_WORN)
      send_to_char(ch, "You cannot wear %s!\r\n", objGetName(obj));
    else {
      obj_from_char(obj);
--- 258,268 ----
    try_scripts(SCRIPT_TYPE_DROP,
  	      obj, SCRIPTOR_OBJ,
  	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
  }
  
  
  void do_wear(CHAR_DATA *ch, OBJ_DATA *obj, const char *where) {
!   if(objIsType(obj, "worn"))
      send_to_char(ch, "You cannot wear %s!\r\n", objGetName(obj));
    else {
      obj_from_char(obj);
***************
*** 294,300 ****
  //*****************************************************************************
  
  bool try_equip(CHAR_DATA *ch, OBJ_DATA *obj, const char *poslist) {
!   if(objGetType(obj) != ITEM_WORN/* && objGetType(obj) != ITEM_WEAPON*/)
      return FALSE;
  
    bool success       = FALSE;
--- 294,300 ----
  //*****************************************************************************
  
  bool try_equip(CHAR_DATA *ch, OBJ_DATA *obj, const char *poslist) {
!   if(!objIsType(obj, "worn"))
      return FALSE;
  
    bool success       = FALSE;
***************
*** 306,312 ****
    // see where we _want_ to equip to
    if(poslist && *poslist)
      wanted = list_postypes(charGetBody(ch), poslist);
!   needed = wornGetPositions(objGetSubtype(obj));
  
    // just equip to the first free slots
    if(!wanted)
--- 306,312 ----
    // see where we _want_ to equip to
    if(poslist && *poslist)
      wanted = list_postypes(charGetBody(ch), poslist);
!   needed = wornGetPositions(obj);
  
    // just equip to the first free slots
    if(!wanted)
***************
*** 534,540 ****
      if(count && at_count == 1) {
        if(found_type)
  	*found_type = FOUND_EDESC;
!       return getEdesc(objGetEdescs(on), at);
      }
      else
        at_count--;
--- 534,540 ----
      if(count && at_count == 1) {
        if(found_type)
  	*found_type = FOUND_EDESC;
!       return edescSetGet(objGetEdescs(on), at);
      }
      else
        at_count--;
***************
*** 870,876 ****
      if(count && at_count == 1) {
        if(found_type)
  	*found_type = FOUND_EDESC;
!       return getEdesc(roomGetEdescs(charGetRoom(looker)), at);
      }
      else
  	at_count--;
--- 870,876 ----
      if(count && at_count == 1) {
        if(found_type)
  	*found_type = FOUND_EDESC;
!       return edescSetGet(roomGetEdescs(charGetRoom(looker)), at);
      }
      else
  	at_count--;
diff -crN nakedmudv1.5/src/handler.d nakedmudv2.0/src/handler.d
*** nakedmudv1.5/src/handler.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/handler.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ handler.d handler.o: handler.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h handler.h room.h exit.h \
+   extra_descs.h character.h object.h utils.h body.h inform.h \
+   scripts/script.h items/items.h items/container.h items/worn.h
diff -crN nakedmudv1.5/src/hashtable.c nakedmudv2.0/src/hashtable.c
*** nakedmudv1.5/src/hashtable.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/hashtable.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 8,31 ****
  //*****************************************************************************
  
  #include <stdlib.h>
  #include <string.h>
  #include "list.h"
  #include "hashtable.h"
  
  struct hashtable_iterator {
    int curr_bucket;
!   struct hashtable *table;
!   struct list_iterator *bucket_i;
  };
  
! struct hashtable_entry {
    char *key;
    void *val;
! };
  
  struct hashtable {
    int num_buckets;
!   struct list **buckets;
  };
  
  
--- 8,32 ----
  //*****************************************************************************
  
  #include <stdlib.h>
+ #include <ctype.h>
  #include <string.h>
  #include "list.h"
  #include "hashtable.h"
  
  struct hashtable_iterator {
    int curr_bucket;
!   HASHTABLE *table;
!   LIST_ITERATOR *bucket_i;
  };
  
! typedef struct hashtable_entry {
    char *key;
    void *val;
! } HASH_ENTRY;
  
  struct hashtable {
    int num_buckets;
!   LIST **buckets;
  };
  
  
***************
*** 38,44 ****
  
    for (i = 0; i < len; i++) {
      base *= BASE;
!     hvalue += key[i] * base;
    }
  
    return (hvalue < 0 ? hvalue * -1 : hvalue);
--- 39,45 ----
  
    for (i = 0; i < len; i++) {
      base *= BASE;
!     hvalue += tolower(key[i]) * base;
    }
  
    return (hvalue < 0 ? hvalue * -1 : hvalue);
***************
*** 48,64 ****
  //
  // an internal form of hashGet that returns the entire entry (key and val)
  //
! struct hashtable_entry *hashGetEntry(struct hashtable *table, const char *key){
    int bucket = hash(key) % table->num_buckets;
  
    if(table->buckets[bucket] == NULL)
      return NULL;
    else {
!     struct list_iterator *list_i = newListIterator(table->buckets[bucket]);
!     struct hashtable_entry *elem = NULL;
  
      for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
!       if(!strcmp(key, elem->key))
  	break;
      deleteListIterator(list_i);
  
--- 49,65 ----
  //
  // an internal form of hashGet that returns the entire entry (key and val)
  //
! HASH_ENTRY *hashGetEntry(HASHTABLE *table, const char *key){
    int bucket = hash(key) % table->num_buckets;
  
    if(table->buckets[bucket] == NULL)
      return NULL;
    else {
!     LIST_ITERATOR *list_i = newListIterator(table->buckets[bucket]);
!     HASH_ENTRY *elem = NULL;
  
      for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
!       if(!strcasecmp(key, elem->key))
  	break;
      deleteListIterator(list_i);
  
***************
*** 66,79 ****
    }
  }
  
! struct hashtable_entry *newHashtableEntry(const char *key, void *val) {
!   struct hashtable_entry *entry = malloc(sizeof(struct hashtable_entry));
    entry->key = strdup(key);
    entry->val = val;
    return entry;
  }
  
! void deleteHashtableEntry(struct hashtable_entry *entry) {
    if(entry->key) free(entry->key);
    free(entry);
  }
--- 67,80 ----
    }
  }
  
! HASH_ENTRY *newHashtableEntry(const char *key, void *val) {
!   HASH_ENTRY *entry = malloc(sizeof(HASH_ENTRY));
    entry->key = strdup(key);
    entry->val = val;
    return entry;
  }
  
! void deleteHashtableEntry(HASH_ENTRY *entry) {
    if(entry->key) free(entry->key);
    free(entry);
  }
***************
*** 85,106 ****
  // documentation in hashtable.h
  //
  //*****************************************************************************
! struct hashtable *newHashtable(int num_buckets) {
    int i;
!   struct hashtable *table = malloc(sizeof(struct hashtable));
    table->num_buckets = num_buckets;
!   table->buckets = malloc(sizeof(struct list *) * num_buckets);
    for(i = 0; i < num_buckets; i++)
      table->buckets[i] = NULL;
    return table;
  }
  
! void  deleteHashtable(struct hashtable *table) {
    int i;
    for(i = 0; i < table->num_buckets; i++) {
      if(table->buckets[i]) {
!       struct hashtable_entry *entry = NULL;
!       while((entry=(struct hashtable_entry *)listPop(table->buckets[i])) !=NULL)
  	deleteHashtableEntry(entry);
        deleteList(table->buckets[i]);
      }
--- 86,107 ----
  // documentation in hashtable.h
  //
  //*****************************************************************************
! HASHTABLE *newHashtable(int num_buckets) {
    int i;
!   HASHTABLE *table = malloc(sizeof(HASHTABLE));
    table->num_buckets = num_buckets;
!   table->buckets = malloc(sizeof(LIST *) * num_buckets);
    for(i = 0; i < num_buckets; i++)
      table->buckets[i] = NULL;
    return table;
  }
  
! void  deleteHashtable(HASHTABLE *table) {
    int i;
    for(i = 0; i < table->num_buckets; i++) {
      if(table->buckets[i]) {
!       HASH_ENTRY *entry = NULL;
!       while((entry=(HASH_ENTRY *)listPop(table->buckets[i])) !=NULL)
  	deleteHashtableEntry(entry);
        deleteList(table->buckets[i]);
      }
***************
*** 110,117 ****
    free(table);
  }
  
! int  hashPut    (struct hashtable *table, const char *key, void *val) {
!   struct hashtable_entry *elem = hashGetEntry(table, key);
  
    // if it's already in, update the value
    if(elem) {
--- 111,118 ----
    free(table);
  }
  
! int  hashPut    (HASHTABLE *table, const char *key, void *val) {
!   HASH_ENTRY *elem = hashGetEntry(table, key);
  
    // if it's already in, update the value
    if(elem) {
***************
*** 125,155 ****
      if(table->buckets[bucket] == NULL)
        table->buckets[bucket] = newList();
  
!     struct hashtable_entry *entry = newHashtableEntry(key, val);
      listPut(table->buckets[bucket], entry);
      return 1;
    }
  }
  
! void *hashGet    (struct hashtable *table, const char *key) {
!   struct hashtable_entry *elem = hashGetEntry(table, key);
    if(elem != NULL)
      return elem->val;
    else
      return NULL;
  }
  
! void *hashRemove (struct hashtable *table, const char *key) {
    int bucket = hash(key) % table->num_buckets;
  
    if(table->buckets[bucket] == NULL)
      return NULL;
    else {
!     struct list_iterator *list_i = newListIterator(table->buckets[bucket]);
!     struct hashtable_entry *elem = NULL;
  
      for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
!       if(!strcmp(key, elem->key))
  	break;
      deleteListIterator(list_i);
  
--- 126,156 ----
      if(table->buckets[bucket] == NULL)
        table->buckets[bucket] = newList();
  
!     HASH_ENTRY *entry = newHashtableEntry(key, val);
      listPut(table->buckets[bucket], entry);
      return 1;
    }
  }
  
! void *hashGet    (HASHTABLE *table, const char *key) {
!   HASH_ENTRY *elem = hashGetEntry(table, key);
    if(elem != NULL)
      return elem->val;
    else
      return NULL;
  }
  
! void *hashRemove (HASHTABLE *table, const char *key) {
    int bucket = hash(key) % table->num_buckets;
  
    if(table->buckets[bucket] == NULL)
      return NULL;
    else {
!     LIST_ITERATOR *list_i = newListIterator(table->buckets[bucket]);
!     HASH_ENTRY *elem = NULL;
  
      for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
!       if(!strcasecmp(key, elem->key))
  	break;
      deleteListIterator(list_i);
  
***************
*** 164,174 ****
    }
  }
  
! int   hashIn     (struct hashtable *table, const char *key) {
!   return (hashGet(table, key) != NULL);
  }
  
! int   hashSize   (struct hashtable *table) {
    int i;
    int size = 0;
  
--- 165,193 ----
    }
  }
  
! int   hashIn     (HASHTABLE *table, const char *key) {
!   int bucket = hash(key) % table->num_buckets;
! 
!   if(table->buckets[bucket] == NULL)
!     return 0;
!   else {
!     int found  = 0;
!     LIST_ITERATOR *list_i = newListIterator(table->buckets[bucket]);
!     HASH_ENTRY *elem = NULL;
! 
!     for(;(elem = listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i)){
!       if(!strcasecmp(key, elem->key)) {
! 	found = 1;
! 	break;
!       }
!     }
!     deleteListIterator(list_i);
! 
!     return found;
!   }
  }
  
! int   hashSize   (HASHTABLE *table) {
    int i;
    int size = 0;
  
***************
*** 186,193 ****
  // documentation in hashtable.h
  //
  //*****************************************************************************
! struct hashtable_iterator *newHashIterator(struct hashtable *table) {
!   struct hashtable_iterator *I = malloc(sizeof(struct hashtable_iterator));
    I->table = table;
    I->bucket_i = NULL;
    hashIteratorReset(I);
--- 205,212 ----
  // documentation in hashtable.h
  //
  //*****************************************************************************
! HASH_ITERATOR *newHashIterator(HASHTABLE *table) {
!   HASH_ITERATOR *I = malloc(sizeof(HASH_ITERATOR));
    I->table = table;
    I->bucket_i = NULL;
    hashIteratorReset(I);
***************
*** 195,206 ****
    return I;
  }
  
! void        deleteHashIterator     (struct hashtable_iterator *I) {
    if(I->bucket_i) deleteListIterator(I->bucket_i);
    free(I);
  }
  
! void        hashIteratorReset      (struct hashtable_iterator *I) {
    int i;
  
    if(I->bucket_i) deleteListIterator(I->bucket_i);
--- 214,225 ----
    return I;
  }
  
! void        deleteHashIterator     (HASH_ITERATOR *I) {
    if(I->bucket_i) deleteListIterator(I->bucket_i);
    free(I);
  }
  
! void        hashIteratorReset      (HASH_ITERATOR *I) {
    int i;
  
    if(I->bucket_i) deleteListIterator(I->bucket_i);
***************
*** 219,225 ****
  }
  
  
! void        hashIteratorNext       (struct hashtable_iterator *I) {
    // no elements in the hashtable
    if(I->bucket_i == NULL) 
      return;
--- 238,244 ----
  }
  
  
! void        hashIteratorNext       (HASH_ITERATOR *I) {
    // no elements in the hashtable
    if(I->bucket_i == NULL) 
      return;
***************
*** 240,251 ****
  }
  
  
! const char *hashIteratorCurrentKey (struct hashtable_iterator *I) {
    if(!I->bucket_i) 
      return NULL;
    else {
!     struct hashtable_entry *entry = ((struct hashtable_entry *)
! 				     listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->key;
      else
--- 259,269 ----
  }
  
  
! const char *hashIteratorCurrentKey (HASH_ITERATOR *I) {
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = ((HASH_ENTRY *) listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->key;
      else
***************
*** 254,265 ****
  }
  
  
! void       *hashIteratorCurrentVal (struct hashtable_iterator *I) {
    if(!I->bucket_i) 
      return NULL;
    else {
!     struct hashtable_entry *entry = ((struct hashtable_entry *)
! 				     listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->val;
      else
--- 272,282 ----
  }
  
  
! void       *hashIteratorCurrentVal (HASH_ITERATOR *I) {
    if(!I->bucket_i) 
      return NULL;
    else {
!     HASH_ENTRY *entry = ((HASH_ENTRY *) listIteratorCurrent(I->bucket_i));
      if(entry)
        return entry->val;
      else
diff -crN nakedmudv1.5/src/hashtable.d nakedmudv2.0/src/hashtable.d
*** nakedmudv1.5/src/hashtable.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/hashtable.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ hashtable.d hashtable.o: hashtable.c list.h hashtable.h
diff -crN nakedmudv1.5/src/hashtable.h nakedmudv2.0/src/hashtable.h
*** nakedmudv1.5/src/hashtable.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/hashtable.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 9,31 ****
  //
  //*****************************************************************************
  
! struct hashtable *newHashtable(int num_buckets);
! void  deleteHashtable(struct hashtable *table);
  
! int   hashPut    (struct hashtable *table, const char *key, void *val);
! void *hashGet    (struct hashtable *table, const char *key);
! void *hashRemove (struct hashtable *table, const char *key);
! int   hashIn     (struct hashtable *table, const char *key);
! int   hashSize   (struct hashtable *table);
! 
! 
! struct hashtable_iterator *newHashIterator(struct hashtable *table);
! void        deleteHashIterator     (struct hashtable_iterator *I);
! 
! void        hashIteratorReset      (struct hashtable_iterator *I);
! void        hashIteratorNext       (struct hashtable_iterator *I);
! const char *hashIteratorCurrentKey (struct hashtable_iterator *I);
! void       *hashIteratorCurrentVal (struct hashtable_iterator *I);
  
  
  #endif // __HASHTABLE_H
--- 9,34 ----
  //
  //*****************************************************************************
  
! typedef struct hashtable                  HASHTABLE;
! typedef struct hashtable_iterator         HASH_ITERATOR;
  
! 
! HASHTABLE *newHashtable(int num_buckets);
! void  deleteHashtable(HASHTABLE *table);
! 
! int   hashPut    (HASHTABLE *table, const char *key, void *val);
! void *hashGet    (HASHTABLE *table, const char *key);
! void *hashRemove (HASHTABLE *table, const char *key);
! int   hashIn     (HASHTABLE *table, const char *key);
! int   hashSize   (HASHTABLE *table);
! 
! HASH_ITERATOR *newHashIterator     (HASHTABLE *table);
! void        deleteHashIterator     (HASH_ITERATOR *I);
! 
! void        hashIteratorReset      (HASH_ITERATOR *I);
! void        hashIteratorNext       (HASH_ITERATOR *I);
! const char *hashIteratorCurrentKey (HASH_ITERATOR *I);
! void       *hashIteratorCurrentVal (HASH_ITERATOR *I);
  
  
  #endif // __HASHTABLE_H
Binary files nakedmudv1.5/src/help/.DS_Store and nakedmudv2.0/src/help/.DS_Store differ
diff -crN nakedmudv1.5/src/help/help.c nakedmudv2.0/src/help/help.c
*** nakedmudv1.5/src/help/help.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/help/help.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 13,18 ****
--- 13,20 ----
  #include "../character.h"
  #include "../socket.h"
  
+ #include "../editor/editor.h"
+ 
  #include "help.h"
  
  
***************
*** 329,336 ****
      if(*ptr == '_') *ptr = ' ';
  
    HELP_DATA *data = get_help_data(arg, FALSE);
!   start_notepad(charGetSocket(ch), (data ? data->info : ""), 
! 		MAX_BUFFER, EDITOR_MODE_NORMAL);
  }
  
  
--- 331,339 ----
      if(*ptr == '_') *ptr = ' ';
  
    HELP_DATA *data = get_help_data(arg, FALSE);
! 
!   socketSetNotepad(charGetSocket(ch), (data ? data->info : ""));
!   socketStartNotepad(charGetSocket(ch));
  }
  
  
***************
*** 342,349 ****
      send_to_char(ch, "Which helpfile were you trying to update?\r\n");
      return;
    }
!   if(!charGetSocket(ch) || !charGetSocket(ch)->notepad || 
!      !*charGetSocket(ch)->notepad) {
      send_to_char(ch, "You have nothing in your notepad! Try writing something.\r\n");
      return;
    }
--- 345,351 ----
      send_to_char(ch, "Which helpfile were you trying to update?\r\n");
      return;
    }
!   if(!charGetSocket(ch) || !*socketGetNotepad(charGetSocket(ch))) {
      send_to_char(ch, "You have nothing in your notepad! Try writing something.\r\n");
      return;
    }
***************
*** 354,360 ****
    for(ptr = arg; *ptr; ptr++)
      if(*ptr == '_') *ptr = ' ';
  
!   update_help(charGetName(ch), arg, charGetSocket(ch)->notepad);
  }
  
  
--- 356,362 ----
    for(ptr = arg; *ptr; ptr++)
      if(*ptr == '_') *ptr = ' ';
  
!   update_help(charGetName(ch), arg, socketGetNotepad(charGetSocket(ch)));
  }
  
  
diff -crN nakedmudv1.5/src/help/help.d nakedmudv2.0/src/help/help.d
*** nakedmudv1.5/src/help/help.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/help/help.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ help/help.d help/help.o: help/help.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h storage.h character.h \
+   socket.h editor/editor.h help/help.h
